// ***************************************************
//   P6toP6T Ver.2.2                                 *
//   2013.12.31  by Yumitaro                         *
// ***************************************************

#include <stdint.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>


// P6T`tH[}bgVer.2
//  {Iɂ́ux^C[W+tb^+x^C[WTCY(4byte)vƂ\
//  tb^ɂDATAubN񂪊܂܂B
//  DATAubN͖؂Ƃ1ƐB
//  BASICȂǁuwb_{f[^vƂ\̏ꍇCDATAubN2ƂȂ邪
//  IDԍ𓯈ɂ邱ƂŊ֘AtĊǗłB
//  {[[g͂Ƃ肠1200{[Œ
//
// [tb^]
//  header (2byte) : "P6"
//  ver    (1byte) : o[W
//  dbnum  (1byte) : ܂܂DATAubN(255܂)
//  start  (1byte) : I[gX^[gtO(0: 1:L)
//  basic  (1byte) : BASIC[h(PC-6001̏ꍇ͖Ӗ)
//  page   (1byte) : y[W
//  askey  (2byte) : I[gX^[gR}h
//  ...R}hꍇ͂̌askey
//  exhead (2byte) : gTCY(64KB܂)
//  ...g񂪂ꍇ͂̌exhead
//
// [DATAubN]
//  header (2byte) : "TI"
//  id     (1byte) : IDԍ(DATAubN֘At)
//  name  (16byte) : f[^(15+'00H')
//  baud   (2byte) : {[[g(600/1200)
//  stime  (2byte) : ̎(ms)
//  ptime  (2byte) : ҁ[̎(ms)
//  start  (4byte) : x^C[W擪̃ItZbg
//  size   (4byte) : f[^TCY



// DATAubN\
typedef struct{
	char header[3];			// ʎq "TI"
	uint8_t id;				// IDԍ
	char name[16];			// f[^(15+'00H')
	uint16_t baud;			// {[[g(600/1200)
	uint16_t stime;			// ̎(ms)
	uint16_t ptime;			// ҁ[̎(ms)
	uint32_t start;			// x^C[W擪̃ItZbg
	uint32_t size;			// f[^TCY
	
	uint8_t *data;			// f[^̈ւ̃|C^(Iňꍇ)
	
} P6DATA;

// P6T\
typedef struct{
	char header[3];			// ʎq "P6"
	uint8_t ver;			// o[W
	uint8_t dbnum;			// ܂܂DATAubN(255܂)
	uint8_t start;			// I[gX^[gtO(0: 1:L)
	uint8_t basic;			// BASIC[h(PC-6001̏ꍇ͖Ӗ)
	uint8_t page;			// y[W
	uint16_t askey;			// I[gX^[gR}hTCY
	uint16_t exhead;		// gTCY(64KB܂)
	
	char fname[260];		// P6T t@C
	FILE *fp;				// TAPE t@C|C^
	uint8_t *exh;			// gi[̈ւ̃|C^
	char *ask;				// I[gX^[gR}hi[̈ւ̃|C^
	P6DATA *db;				// DATAubNւ̃|C^
	uint32_t beta;			// x^C[WTCY
	int mode;				// OPEN[h(TAPE_LOAD/TAPE_SAVE)
	int dbsel;				// IĂDATAubNԍ(0-254)
	int seek;				// IĂDATAubÑV[Nʒu(f[^̈擪0)
	int swait;				// ̑҂
	int pwait;				// ҁ[̑҂
} P6CAS;

// e[v̎
char *TapeType[] = {"= QUIT =",
					"x^",
					"BASIC",
					"I/Oj^",
					"CeHEX(MON)",
				};

#define	NumOfType	5
#define	StdP		3400
#define	IOP			3400
#define	BAS			50
#define	IOS			1000

#define	StdBaud		1200


P6CAS *fout=NULL;	// P6T|C^
P6DATA *fdb[255];	// DATAubN|C^z

FILE *infp = NULL;	// ̓t@C|C^
uint32_t fsize = 0;		// ̓t@C̃TCY
uint8_t idnum = 0;	// DATAubNIDԍ


// DATAubN ̈m & 
P6DATA *get_dbblock( P6CAS *ft )
{
	if( !(fdb[ft->dbnum]=(P6DATA *)malloc( sizeof(P6DATA) )) ) exit( 1 );
	memset( fdb[ft->dbnum], 0, sizeof(P6DATA) );
	strncpy( fdb[ft->dbnum]->header, "TI", 2 );
	
	return fdb[ft->dbnum++];
}


// f[^TCY
// EnteȑꍇmaxԂ
uint32_t input_datasize( uint32_t max )
{
	uint32_t dsize=0;
	char tmp[80];	// TCY͗pobt@
	
	while( !dsize ){
		gets( tmp );
		
		if( strlen( tmp ) ) dsize = atol( tmp );
		else                dsize = max;
		
		if( !dsize ) printf("͂܂B\n> ");
	}
	return dsize;
}


// x^ Ǎ
void read_beta( P6CAS *ft, FILE *infp, FILE *outfp )
{
	P6DATA *db;
	uint32_t bsize=0;
	int i;
	
	
	// TCY
	printf( "TCY͂ĉBiSĂ̏ꍇ͉͂Enterj\n> " );
	bsize = input_datasize( fsize - ftell( infp ) );
	
	
	db = get_dbblock( ft );	// DATAubN ̈m & 
	
	// DATAubNZbg
	db->id     = idnum++;			// IDԍ
	db->baud   = StdBaud;			// {[[g
	db->stime  = StdP;				// ̎(ms)
	db->ptime  = StdP;				// ҁ[̎(ms)
	db->start  = ftell( outfp );	// x^C[W擪̃ItZbg
	db->size   = bsize;				// f[^TCY
	
	// f[^Zbg
	for( i=0; i<(int)bsize; i++ ) fputc( fgetc( infp ), outfp );
}


// BASIC Ǎ
void read_basic( P6CAS *ft, FILE *infp, FILE *outfp )
{
	P6DATA *db;
	uint32_t bsize=0,fpnt;
	int i,sum=0;
	
	// *** ܂̓wb_ ***
	db = get_dbblock( ft );	// DATAubN ̈m & 
	
	// wb_D3Hǂݔ΂
	while( fgetc( infp ) != 0xd3 );	// D3H܂ŋǂ
	while( fgetc( infp ) == 0xd3 );	// D3HȊO܂ŋǂ
	fseek( infp, -1, SEEK_CUR );	// s߂߂
	
	// DATAubNZbg
	db->id     = idnum;				// IDԍ
	fread( db->name, 1, 6, infp );	// f[^(BASIC̃t@C)
	db->baud   = StdBaud;			// {[[g
	db->stime  = StdP;				// ̎(ms)
	db->ptime  = StdP;				// ҁ[̎(ms)
	db->start  = ftell( outfp );	// x^C[W擪̃ItZbg
	db->size   = 16;				// f[^TCY
	
	// f[^Zbg
	for( i=0; i<10; i++ ) fputc( 0xd3, outfp );	// wb_D3H
	fwrite( db->name, 6, 1, outfp );			// BASIC̃t@C
	
	
	// *** Ƀf[^ ***
	db = get_dbblock( ft );	// DATAubN ̈m & 
	
	// ubNTCY𒲂ׂăf[^̈m
	fpnt = ftell( infp );			// ݈ʒuۑ
	do{								// 00H10o܂ŋǂ
		if( fgetc( infp ) == 0 ) sum++;
		else                     sum = 0;
		bsize++;
	}while( sum < 10 );
	fseek( infp, fpnt, SEEK_SET );	// ̈ʒuɖ߂
	
	// DATAubNZbg
	db->id     = idnum++;			// IDԍ
	db->baud   = StdBaud;			// {[[g
	db->stime  = 0;					// ̎(ms)
	db->ptime  = BAS;				// ҁ[̎(ms)
	db->start  = ftell( outfp );	// x^C[W擪̃ItZbg
	db->size   = bsize;				// f[^TCY
//	db->size   = bsize+2;			// f[^TCY(Gh}[NŌ2byte܂)
	
	// f[^Zbg
	for( i=0; i<(int)bsize; i++ ) fputc( fgetc( infp ), outfp );
	
	// Gh}[N00HcĂꍇ̏
//	if( fgetc( infp ) ) fseek( infp, -1, SEEK_CUR );	// 00HłȂΖ߂
//	if( fgetc( infp ) ) fseek( infp, -1, SEEK_CUR );	// 00HłȂΖ߂
//	fputc( 0, outfp );	// 00Ho
//	fputc( 0, outfp );	// 00Ho
}


// I/Oj^` Ǎ
void read_iomon( P6CAS *ft, FILE *infp, FILE *outfp )
{
	P6DATA *db;
	uint32_t bsize=0;
	int i;
	
	// *** ܂̓wb_ ***
	db = get_dbblock( ft );	// DATAubN ̈m & 
	
	// wb_9CHǂݔ΂
	while( fgetc( infp ) != 0x9c );
	while( fgetc( infp ) != 0xaf );
	// wb_AFHǂݔ΂
	while( fgetc( infp ) == 0xaf );
	fseek( infp, 1, SEEK_CUR );
	
	bsize = ( getc(infp) | getc(infp)<<8 ) + 7;	// f[^̎f[^TCY擾(wb_9CH*6+1(?)Z)
	
	// DATAubNZbg
	db->id     = idnum;				// IDԍ
	db->baud   = StdBaud;			// {[[g
	fgets( db->name, 3, infp );		// f[^(2̃t@C)
	db->stime  = StdP;				// ̎(ms)
	db->ptime  = StdP;				// ҁ[̎(ms)
	db->start  = ftell( outfp );	// x^C[W擪̃ItZbg
	db->size   = 17;				// f[^TCY
	
	// f[^Zbg
	for( i=0; i<6; i++ ) fputc( 0x9c, outfp );			// wb_9CH
	for( i=0; i<5; i++ ) fputc( 0xaf, outfp );			// wb_AFH
	fseek( infp, -6, SEEK_CUR );
	for( i=0; i<6; i++ ) fputc( fgetc( infp ), outfp );	// AhXCTCYCt@C
	
	
	// *** Ƀf[^ ***
	db = get_dbblock( ft );	// DATAubN ̈m & 
	
	// DATAubNZbg
	db->id     = idnum++;			// IDԍ
	db->baud   = StdBaud;			// {[[g
	db->stime  = IOS;				// ̎(ms)
	db->ptime  = IOP;				// ҁ[̎(ms)
	db->start  = ftell( outfp );	// x^C[W擪̃ItZbg
	db->size   = bsize;				// f[^TCY
	
	// f[^Zbg
	for( i=0; i<(int)bsize; i++ ) fputc( fgetc( infp ), outfp );
}


// CeHEX Ǎ
void read_ihex( P6CAS *ft, FILE *infp, FILE *outfp )
{
	P6DATA *db;
	int i,sum=0;
	uint32_t bsize=0,fpnt;
	
	db = get_dbblock( ft );	// DATAubN ̈m & 
	
	// wb_9CHo
	while( fgetc( infp ) != 0x9c );
	fseek( infp, -1, SEEK_CUR );
	
	// ubNTCY𒲂ׂ
	fpnt = ftell( infp );	// ݈ʒuۑ
	
	fseek( infp, 9, SEEK_CUR );
	// 30H16o܂ŋǂ
	do{
		sum = 0;
		for( i=0; i<16; i++ ){
			if( fgetc( infp ) == 0x30 ) sum++;
			else                        sum = 0;
		}
		if( sum==16 && (fgetc( infp )==0x1a) ) break;
		else fseek( infp, 29, SEEK_CUR );
	}while( 1 );
	bsize = ftell( infp ) - fpnt;
	fseek( infp, fpnt, SEEK_SET );
	
	
	// DATAubNZbg
	db->id     = idnum++;			// IDԍ
	db->baud   = StdBaud;			// {[[g
	db->stime  = StdP;				// ̎(ms)
	db->ptime  = StdP;				// ҁ[̎(ms)
	db->start  = ftell( outfp );	// x^C[W擪̃ItZbg
	db->size   = bsize;				// f[^TCY
	
	// f[^Zbg
	for( i=0; i<(int)bsize; i++ ) fputc( fgetc( infp ), outfp );
}





// P6Ttb^o
void p6_footer( P6CAS *ft )
{
	// "P6"
	fputc( 'P', ft->fp );
	fputc( '6', ft->fp );
	// o[W(2)
	fputc( 2, ft->fp );
	// ܂܂DATAubN
	fputc(  ft->dbnum, ft->fp );
	// I[gX^[gtO(0: 1:L)
	fputc(  ft->start, ft->fp );
	// BASIC[h(PC-6001̏ꍇ͖Ӗ)
	fputc(  ft->basic, ft->fp );
	// y[W
	fputc(  ft->page, ft->fp );
	// I[gX^[gR}h
	fputc(  ft->askey    &0xff, ft->fp );
	fputc( (ft->askey>>8)&0xff, ft->fp );
	// I[gX^[gR}h
	if( ft->askey )
		ft->ask[ft->askey-1] = 0x0d;
		fwrite( ft->ask, ft->askey, 1, ft->fp );
	// gTCY
	fputc(  ft->exhead    &0xff, ft->fp );
	fputc( (ft->exhead>>8)&0xff, ft->fp );
	// g
	if( ft->exhead )
		fwrite( ft->exh, ft->exhead, 1, ft->fp );
}


// DATAubNo
void db_info( P6DATA *db, FILE *fp )
{
	// "TI"
	fputc( 'T', fp );
	fputc( 'I', fp );
	// IDԍ
	fputc( db->id, fp );
	// f[^
	fwrite( db->name, 16, 1, fp );
	// {[[g
	fputc(  db->baud    &0xff, fp );
	fputc( (db->baud>>8)&0xff, fp );
	// ̎
	fputc(  db->stime    &0xff, fp );
	fputc( (db->stime>>8)&0xff, fp );
	// ҁ[̎
	fputc(  db->ptime    &0xff, fp );
	fputc( (db->ptime>>8)&0xff, fp );
	// x^C[W擪̃ItZbg
	fputc(  db->start     &0xff, fp );
	fputc( (db->start>>8) &0xff, fp );
	fputc( (db->start>>16)&0xff, fp );
	fputc( (db->start>>24)&0xff, fp );
	// f[^TCY
	fputc(  db->size     &0xff, fp );
	fputc( (db->size>>8) &0xff, fp );
	fputc( (db->size>>16)&0xff, fp );
	fputc( (db->size>>24)&0xff, fp );
	
	printf( "IDԍ        :%d\n",         db->id );
	printf( "f[^      :%s\n",         db->name );
	printf( "̎  :%d(%04X)\n",   db->stime,  db->stime );
	printf( "ҁ[̎  :%d(%04X)\n",   db->ptime,  db->ptime );
	printf( "ItZbg    :%d(%08X)\n",   db->start,  db->start );
	printf( "f[^TCY  :%d(%08X)\n",   db->size,   db->size );
}



int main( int argc, char **argv )
{
	int i;
	char *c;
	uint8_t type;			// e[v̎
	uint32_t fpnt=0;		// t@C|C^ۑp
	uint32_t totalsize=0;	// x^C[W̃g[^TCY
	
	printf( "=== P6toP6T2 ===\n" );
	
	if( argc < 2 ){
		fprintf( stderr, "Usage: p6top6t2 inputfile\n" );
		exit( 1 );
	}
	
	printf( "'%s'̕ϊJn܂B\n", argv[1] );
	
	// P6T ̈m & 
	if( !(fout=(P6CAS *)malloc( sizeof(P6CAS) ))) exit( 1 );
	memset( fout, 0, sizeof(P6CAS) );
	strncpy( fout->header, "P6", 2 );
	// o̓t@Cݒ
	strcpy( fout->fname, argv[1] );
	strcpy( strrchr( fout->fname, '.' ), ".p6t" );
	
	// DATAubN|C^z 
	for( i=0; i<255; i++ ) fdb[i] = NULL;
	
	
	// I[gX^[gI
	do{
		printf( "I[gX^[gLɂ܂H (0:No 1:Yes)>" );
		fout->start = getchar() - '0';
		getchar();	// Enterǂ
	}while( fout->start > 1 );
	
	if( fout->start ){
		// BASIC[hI
		do{
			printf( "BASIC[hIł (1-6)>" );
			fout->basic = getchar() - '0';
			getchar();	// Enterǂ
		}while( fout->basic < 1 || fout->basic > 6 );
		
		// y[WI
		do{
			printf( "y[WIł (1-4)>" );
			fout->page = getchar() - '0';
			getchar();	// Enterǂ
		}while( fout->page < 1 || fout->page > 4 );
		
		// I[gX^[gR}h
		if( !(fout->ask=malloc( sizeof(char)*512 )) ) exit( 1 );	// Ƃ肠512byteΏ\?
		printf( "I[gX^[gR}h͂Ăis'\\n' LOADI҂'\\r' ɂ͕svj\n" );
		printf( "'CLOAD\\rRUN' ̏ꍇ͉͂Enter\n> " );
		gets( fout->ask );
		// ͂Ȃ"CLOAD RUN"
		if( !strlen( fout->ask ) ) strcpy( fout->ask, "CLOAD\\rRUN" );
		// GXP[vV[PX̏
		do{
			c = (char *)strchr( fout->ask, (int)'\\' );
			if( c ){
				switch( c[1] ){
				case 'n':	// s
					c[0] = 0x0d;
					strcpy( &c[1], &c[2] );
					break;
				case 'r':	// e[v[҂
					c[0] = 0x0a;
					strcpy( &c[1], &c[2] );
					break;
				default:
					printf( "!! '%c' sȐ䕶łB", c[1] );
					exit( 1 );
				}
			}
		}while( c );
		
		fout->askey = strlen( fout->ask ) + 1;
	}
	
	// ̓t@CJ
	if( (infp=fopen(argv[1], "rb")) == NULL ){
		fprintf( stderr, "p6top6t2: ̓t@CJ܂ '%s'\n", argv[1] );
		exit( 1 );
	}
	// ̓t@CTCY擾
	fseek( infp, 0, SEEK_END );
	fsize = ftell( infp );
	fseek( infp, 0, SEEK_SET );
	
	// o̓t@CJ
	if( (fout->fp=fopen( fout->fname, "wb")) == NULL ){
		fprintf( stderr, "p6top6t2: o̓t@CJ܂ '%s'\n", fout->fname );
		exit( 1 );
	}
	
	
	do{
		printf("\n %d (/%d)\n\n", (int)fpnt, (int)fsize );
		// e[v̎ނI
		printf( "<< e[v̎ނIł >>\n" );
		for( i=0; i<NumOfType; i++ )
			printf( "%d. %s\n", i, TapeType[i] );
		type = getchar() - '0';
		getchar();	// Enterǂ
		
		// f[^ubNo
		switch( type ){
		case 0:	// - QUIT -
			fsize = 0;
			break;
		case 1:	// BETA
			read_beta( fout, infp, fout->fp );
			break;
		case 2:	// BASIC
			read_basic( fout, infp, fout->fp );
			break;
		case 3:	// I/O
			read_iomon( fout, infp, fout->fp );
			break;
		case 4:	// CeHEX
			read_ihex( fout, infp, fout->fp );
			break;
		}
		fpnt = ftell( infp );
	}while( fpnt > 0 && fpnt < fsize );
	
	fout->ver = 2;	// P6T Ver.2
	// P6Ttb^o
	p6_footer( fout );
	
	// DATAubNo
	for( i=0; i<fout->dbnum; i++ ){
		printf( "<< Block No.%d >>\n", i );
		db_info( fdb[i], fout->fp );
		totalsize += fdb[i]->size;
	}
	
	// x^C[WTCYo
	fputc(  totalsize     &0xff, fout->fp );
	fputc( (totalsize>>8) &0xff, fout->fp );
	fputc( (totalsize>>16)&0xff, fout->fp );
	fputc( (totalsize>>24)&0xff, fout->fp );
	
	
	// ̓t@C
	fclose( infp );
	
	// o̓t@C
	fclose( fout->fp );
	
	// DATAubN̈J
	for( i=0; i<fout->dbnum; i++ ) free( fdb[i] );
	
	// P6T̈J
	free( fout->ask );
	free( fout );
	
	printf( "t@C̕ϊ܂B\n" );
	
	return 0;
}
